Hooks:PostHook(HUDTeammate, "init", "LDDGTeammateInit", function(self, i, teammates_panel, is_player, width) 
self._player_panel:child("radial_health_panel"):hide()
	self._player_panel:child("weapons_panel"):hide()
	self._panel:child("name_bg"):hide()
 	self._panel:child("callsign_bg"):hide()
 	self._player_panel:child("carry_panel"):set_alpha(0)

 	local scale = LDDG:GetSetting("HudScale")

 	local text_size = (self._main_player and 24 or 20) * scale

 	local color = LDDG:GetColor("TeammatesColor")
	--Part 1 : Equipment
	local portrait = self._panel:bitmap({
	    name = "portrait",
	    w = (self._main_player and 92 or 48) * scale,
	    h = (self._main_player and 92 or 48) * scale,
	    texture = character_texture,
	})
	portrait:set_bottom(self._panel:h())

	self._panel:remove(self._panel:child("name"))
	local name = self._panel:text({
	    name = "name",
	    text = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA",	    
	    x = portrait:right() + 10,
	    font = "fonts/font_large_mf",
	    color = color,
	    font_size = text_size,	
	})

	local health_text = self._player_panel:text({
	    name = "health_text",
	    text = managers.localization:text("LDDG_Health"),
	    x = portrait:right() + 10,
	    font = "fonts/font_large_mf",
	    color = color,
	    font_size = text_size,
	})
	local health = self._player_panel:text({
	    name = "health",
	    text = " 100",
	    align = "right",
	    font = "fonts/font_large_mf",
	    font_size = text_size,
	    color = color,
	})

	local armor_text = self._player_panel:text({
	    name = "armor_text",
	    text = managers.localization:text("LDDG_Armor"),
	    x = portrait:right() + 10,
	    font = "fonts/font_large_mf",
	    font_size = text_size,
	    color = color,
	})
	local armor = self._player_panel:text({
	    name = "armor",
	    text = " 100",
	    align = "right",
	    font = "fonts/font_large_mf",
	    font_size = text_size,
	    color = color,
	})	
	local bar1 = self._player_panel:rect({
	    name = "bar1",
	    w = portrait:w(),
	    h = 4 * scale,	 
	    layer = 10,   
	    visible = false,
	    color = Color.blue,
	})	
	local bar1_bg = self._player_panel:rect({
	    name = "bar1_bg",
	    w = portrait:w(),
	    h = 4 * scale,	 
	    layer = 10,   
	    visible = false,
	    alpha = 0.4,
	    color = Color.black,
	})
	local bar2 = self._player_panel:rect({
	    name = "bar2",
	    w = portrait:w(),
	    h = 4 * scale,	  
	    layer = 10,  
	    visible = false,
	    color = Color.green,
	})
	bar1:set_bottom(portrait:bottom())
	bar1_bg:set_y(bar1:y())
	bar2:set_bottom(bar1:top())


	local ammo_text = self._player_panel:text({
	    name = "ammo_text",
	    text = managers.localization:text("LDDG_Ammo"),
	    x = portrait:right() + 10,
	    font = "fonts/font_large_mf",
	    font_size = text_size,
	    color = color,
	})
	for i=1,2 do
	    local is_secondary = i==1
	    local wep_panel = self._player_panel:panel({
	        name = (is_secondary and "secondary" or "primary") .."_panel",
	        layer = 3,
	    })          
	    local current_clip = wep_panel:text({
	        name = "current_clip",
	        align = "right",
	        font_size = text_size,
	        font = "fonts/font_large_mf",
	        color = color,
	    })     
	    local split_ammo = wep_panel:text({
	        name = "split_ammo",
	        text = "/",
	        align = "center",
	        font_size = text_size,
	        font = "fonts/font_large_mf",
	        color = color,
	    }) 
	    local total_ammo = wep_panel:text({
	        name = "total_ammo",
	        font_size = text_size,
	        font = "fonts/font_large_mf",
	        color = color,
	    })	    
	    local fire_mode = wep_panel:text({
	        name = "fire_mode",
	        text = ":",
	        visible = self._main_player,
	        font_size = text_size - 10,
	        font = "fonts/font_large_mf",
	        color = color,
	    })
	end	
	self._player_panel:child("grenades_panel"):child("bg"):hide()
	self._player_panel:child("cable_ties_panel"):child("bg"):hide()
	self._player_panel:child("deployable_equipment_panel"):child("bg"):hide()
   	self:UpdateLDDG() 
end)
function HUDTeammate:UpdateLDDG()
 	managers.hud:align_teammate_panels()
  	local color = LDDG:GetColor("TeammatesColor")	
  	local scale = LDDG:GetSetting("HudScale")
  	local text_size = (self._main_player and 24 or 20) * scale
  	local primary_panel = self._player_panel:child("primary_panel")		
	local secondary_panel = self._player_panel:child("secondary_panel")
	local name = self._panel:child("name")
	local health_text = self._player_panel:child("health_text")
	local health = self._player_panel:child("health")
	local armor_text = self._player_panel:child("armor_text")
	local armor = self._player_panel:child("armor")
	local ammo_text = self._player_panel:child("ammo_text")
	local grenades_panel = self._player_panel:child("grenades_panel")
	local cable_ties_panel = self._player_panel:child("cable_ties_panel")
	local deployable_equipment_panel = self._player_panel:child("deployable_equipment_panel")
	local grenades = grenades_panel:child("grenades")
	local cable_ties = cable_ties_panel:child("cable_ties")
	local equipment = deployable_equipment_panel:child("equipment")
	local portrait = self._panel:child("portrait")
	local bar1 = self._player_panel:child("bar1")
	local bar1_bg = self._player_panel:child("bar1_bg")
	local bar2 = self._player_panel:child("bar2")
	portrait:set_size((self._main_player and 92 or 48) * scale, (self._main_player and 92 or 48) * scale)
	bar1:set_h(4 * scale)
	bar1_bg:set_h(bar1:h())
	bar2:set_h(bar1:h())
	bar1:set_bottom(self._panel:h())
	bar1_bg:set_y(bar1:y())
	bar2:set_bottom(bar1:top())
	local elements = {
		name,
		health_text,
		armor_text,
		ammo_text,
	}	

	local old_text = health:text()
	health:configure({
		color = color, 
		font_size = text_size,
		text = "100",
	})
	managers.hud:make_fine_text(health)
	health:set_text(old_text)	

	local old_text = armor:text()
	armor:configure({
		color = color, 
		font_size = text_size,
		text = "100",
	})
	managers.hud:make_fine_text(armor)
	armor:set_text(old_text)	

	for _, element in pairs(elements) do
	  	element:configure({
	  		color = color, 
	  		font_size = text_size,
	  		x = self._panel:child("portrait"):right() + 10,
	  	})
	  	managers.hud:make_fine_text(element)
	end	

	ammo_text:set_world_bottom(self._player_panel:world_bottom())
	armor_text:set_bottom(ammo_text:top())		
	if self._main_player then		
		health_text:set_bottom(armor_text:top())		
		health:set_lefttop(health_text:right() + 4, health_text:top())	
	else
		health_text:set_bottom(ammo_text:top())	
		health:set_lefttop(health_text:right() + 4, health_text:top())	
		armor_text:set_leftbottom(health:right() + 4, health_text:bottom())
	end		
	armor:set_lefttop(armor_text:right() + 4, armor_text:top())
	if not self._ai then
		name:set_bottom(health_text:top())
	else
		name:set_center_y(self._panel:child("portrait"):center_y())
	end	 
	self._panel:child("callsign"):set_size(name:h() / 2, name:h() / 2)
	self._panel:child("callsign"):set_right(name:left() + 2)
	self._panel:child("callsign"):set_center_y(name:center_y())	
	self._panel:child("condition_icon"):set_size(text_size + 4, text_size + 4)
	self._panel:child("condition_icon"):set_world_leftbottom(self._panel:world_left(), self._panel:world_bottom())
	self._panel:child("condition_timer"):set_font_size(text_size)
	self._panel:child("condition_timer"):set_size(text_size, text_size)
	self._panel:child("condition_timer"):set_center(self._panel:child("condition_icon"):center())

	for i=1,2 do
		local is_secondary = i==1
		local wep_panel = self._player_panel:child((is_secondary and "secondary" or "primary") .."_panel")
		local current_clip = wep_panel:child("current_clip")
		local split_ammo = wep_panel:child("split_ammo")
		local fire_mode = wep_panel:child("fire_mode")		
		local total_ammo = wep_panel:child("total_ammo")
		wep_panel:configure({
			h = text_size,
		})	
		local old_text = current_clip:text()		
	    current_clip:configure({
	    	color = color,
	        font_size = text_size,
	        text = "999",
	    })     
	    managers.hud:make_fine_text(current_clip)
	    current_clip:set_text(old_text)
	    split_ammo:configure({
			color = color,
	        font_size = text_size,
	    }) 
	    managers.hud:make_fine_text(split_ammo)
	    split_ammo:set_left(current_clip:right()) 

	    local old_text = total_ammo:text()		
	    total_ammo:configure({
			color = color,
	        font_size = text_size,
	        text = "999",	        
	    })
	    managers.hud:make_fine_text(total_ammo)
	    total_ammo:set_left(split_ammo:right()) 
	    total_ammo:set_text(old_text)	    
	    fire_mode:configure({
			color = color,
	        font_size = text_size,
	    })
	    managers.hud:make_fine_text(fire_mode)	   
	    fire_mode:set_left(total_ammo:right() + 1)		
	    wep_panel:set_w(total_ammo:w() + split_ammo:w() + current_clip:w() + fire_mode:w() + 1)
	    wep_panel:set_lefttop(ammo_text:right() + 4, ammo_text:top())
	end
	self:recreate_weapon_firemode()


	local eq_h = 64 / (PlayerBase.USE_GRENADES and 3 or 2)
	local eq_w = 48
    local padding = 2 * scale

    deployable_equipment_panel:set_size(eq_w * scale, eq_h * scale)
    equipment:set_size(eq_h * scale, eq_h * scale)
    equipment:set_x((10 * scale))
    equipment:set_color(color)
    equipment:set_center_y(deployable_equipment_panel:h() / 2.2)
    local amount = deployable_equipment_panel:child("amount")
    amount:set_font_size(22 * scale)
    amount:set_h(22 * scale)
    amount:set_color(color)
    amount:set_center_y(equipment:center_y())
    amount:set_right(deployable_equipment_panel:w())
    deployable_equipment_panel:set_leftbottom(0, name:top() - padding)

    cable_ties_panel:set_size(eq_w * scale, eq_h * scale)
    cable_ties:set_size(eq_h * scale, eq_h * scale)
    cable_ties:set_x((10 * scale))
    cable_ties:set_color(color)
    cable_ties:set_center_y(cable_ties_panel:h() / 2.2)
    local amount = cable_ties_panel:child("amount")
    amount:set_font_size(22 * scale)
    amount:set_h(22 * scale)	    
    amount:set_center_y(cable_ties:center_y())
    amount:set_color(color)
    amount:set_right(cable_ties_panel:w())
    cable_ties_panel:set_leftbottom(deployable_equipment_panel:right() + (32 * scale), name:top() - padding)

    grenades_panel:set_size(eq_w * scale, eq_h * scale)
    grenades:set_size(eq_h * scale, eq_h * scale)
    grenades:set_center_y(grenades_panel:h() / 2.2)
    grenades:set_color(color)
    grenades:set_x((10 * scale))
    local amount = grenades_panel:child("amount") 
    amount:set_font_size(22 * scale)
    amount:set_h(22 * scale)	    
    amount:set_center_y(grenades:center_y())
    amount:set_right(grenades_panel:w())
    amount:set_color(color)
    grenades_panel:set_leftbottom(cable_ties_panel:right() + (32 * scale), name:top() - padding)
    self:layout_special_equipments()
	self:set_player_portrait()
 end
 function HUDTeammate:_set_amount_string(text, amount)
	if not PlayerBase.USE_GRENADES then
		text:set_text(tostring(amount))
		return
	end
	text:set_text(amount)
end
 function HUDTeammate:set_weapon_firemode(id, firemode)
 	if not self._player_panel:child("primary_panel") then
 		return
 	end
	local is_secondary = id == 1	
	local primary = self._player_panel:child("primary_panel"):child("fire_mode")
	local secondary = self._player_panel:child("secondary_panel"):child("fire_mode")
	local weapon_selection = is_secondary and secondary or primary
	if alive(weapon_selection) then
		weapon_selection:set_text(firemode == "single" and "." or ":")
	end
end
 function HUDTeammate:add_panel()
	local teammate_panel = self._panel
	teammate_panel:set_visible(true)
	self:set_player_portrait()
end
function HUDTeammate:set_state(state)
	local is_player = state == "player"
	self._player_panel:set_alpha(is_player and 1 or 0)
	local name = self._panel:child("name")
	self:set_player_portrait()
	if is_player then
		name:set_bottom(self._player_panel:child("health_text"):top())
	else
		name:set_center_y(self._panel:child("portrait"):center_y())
		self._panel:child("callsign"):set_center_y(self._panel:child("portrait"):center_y())
	end
	self:UpdateLDDG()
end
function HUDTeammate:_create_primary_weapon_firemode()
	local equipped_primary = managers.blackmarket:equipped_primary()
	local weapon_tweak_data = tweak_data.weapon[equipped_primary.weapon_id]
	local fire_mode = weapon_tweak_data.FIRE_MODE
	local can_toggle_firemode = weapon_tweak_data.CAN_TOGGLE_FIREMODE
	local locked_to_auto = managers.weapon_factory:has_perk("fire_mode_auto", equipped_primary.factory_id, equipped_primary.blueprint)
	local locked_to_single = managers.weapon_factory:has_perk("fire_mode_single", equipped_primary.factory_id, equipped_primary.blueprint)	
	self:set_weapon_firemode(2, locked_to_single or not locked_to_auto and fire_mode == "single" and "single" or "auto")
end
function HUDTeammate:_create_secondary_weapon_firemode()
	local equipped_secondary = managers.blackmarket:equipped_secondary()
	local weapon_tweak_data = tweak_data.weapon[equipped_secondary.weapon_id]
	local fire_mode = weapon_tweak_data.FIRE_MODE
	local can_toggle_firemode = weapon_tweak_data.CAN_TOGGLE_FIREMODE
	local locked_to_auto = managers.weapon_factory:has_perk("fire_mode_auto", equipped_secondary.factory_id, equipped_secondary.blueprint)
	local locked_to_single = managers.weapon_factory:has_perk("fire_mode_single", equipped_secondary.factory_id, equipped_secondary.blueprint) 	
	self:set_weapon_firemode(1, locked_to_single or not locked_to_auto and fire_mode == "single" and "single" or "auto")
end
function HUDTeammate:set_name(teammate_name)
	local name = self._panel:child("name")
	local callsign = self._panel:child("callsign")
	name:set_text(" " .. teammate_name)
	managers.hud:make_fine_text(name)
	callsign:set_right(name:left() + 2)
	callsign:set_center_y(name:center_y())
	self:UpdateLDDG()
end
function HUDTeammate:set_player_portrait()
	local character
	if self._main_player then
		character = managers.criminals:character_name_by_unit(managers.player:player_unit())
	elseif self._ai then
		character = managers.criminals:character_name_by_panel_id(self._id)
	else
		character = managers.criminals:character_name_by_peer_id(self._peer_id)
	end
	if character then 
	 	character_name = CriminalsManager.convert_old_to_new_character_workname(character)
		local guis_catalog = "guis/"
		local character_table = tweak_data.blackmarket.characters[character] or tweak_data.blackmarket.characters.locked[character_name]
		local bundle_folder = character_table and character_table.texture_bundle_folder
		if bundle_folder then
		    guis_catalog = guis_catalog .. "dlcs/" .. tostring(bundle_folder) .. "/"
		end
		character_texture = guis_catalog .. "textures/pd2/blackmarket/icons/characters/" .. tostring(character_name)
		self._panel:child("portrait"):set_image(character_texture)
		self._panel:child("portrait"):set_world_bottom(self._player_panel:world_bottom())
	end
end

function HUDTeammate:set_condition(icon_data, text)
	local condition_icon = self._panel:child("condition_icon")
	if icon_data == "mugshot_normal" then
		condition_icon:set_visible(false)
	else
		condition_icon:set_visible(true)
		local icon, texture_rect = tweak_data.hud_icons:get_icon_data(icon_data)
		condition_icon:set_image(icon, texture_rect[1], texture_rect[2], texture_rect[3], texture_rect[4])
	end
	self:set_player_portrait()
end
Hooks:PostHook(HUDTeammate, "set_health", "LDDGSetHealth", function(self, data)    
local health = self._player_panel:child("health")
	local Value = data.current / data.total * 100
	health:set_text(math.floor(Value))	
	if math.floor(Value) > 0 then 
		if (self._lastvalue and self._lastvalue < Value) and (Value - self._lastvalue) > 9  then
			health:animate(callback(self, self, "health_full"), self._lastvalue, Value)
		end
		if self._lastvalue and Value < self._lastvalue then
			health:animate(callback(nil, _G, "set_color"), Color.red, 0.3)
		end
	end			
	health:animate(callback(nil, _G, "set_color"), LDDG:GetColor("TeammatesColor"), 0.2)
	self._lastvalue = Value
end)
Hooks:PostHook(HUDTeammate, "set_armor", "LDDGSetArmor", function(self, data)    
	local armor = self._player_panel:child("armor")
	local Value = data.current / data.total
	armor:set_text(math.floor(Value * 100))
end)
function HUDTeammate:health_full(health, lastvalue, value)
	local t = 0
	local size = (self._main_player and 24 or 20) * LDDG:GetSetting("HudScale")
	while t < 1 do
		t = t + coroutine.yield()
		local n = 1 - math.sin((t / 2) * 180)
		hp = math.clamp(lastvalue + (t * 100), 0, value)
		health:set_text(math.floor(hp))
	end
	health:set_font_size(size)
	health:set_text(math.floor(self._lastvalue))
end
Hooks:PostHook(HUDTeammate, "set_custom_radial", "LDDGSetCustomRadial", function(self, data)    
	local health = self._player_panel:child("health")
	local color = LDDG:GetColor("TeammatesColor")
	local red = data.current / data.total
	local Value = red * 100
	if red > 0 then
		health:animate(callback(nil, _G, "set_color"), Color.red)		
		health:set_text(math.floor(Value))
	else
		if health:color() ~= color then
			health:animate(callback(nil, _G, "set_color"), color)
		end
	end	
end)
function HUDTeammate:_set_weapon_selected(id, hud_icon)
	local is_secondary = id == 1
	local secondary_weapon_panel = self._player_panel:child("secondary_panel")
	local primary_weapon_panel = self._player_panel:child("primary_panel")
	primary_weapon_panel:animate(callback(self, self, "set_weapon"), secondary_weapon_panel, is_secondary and 0 or 1,  is_secondary and 1 or 0)
end
function HUDTeammate:set_weapon(prim, sec, pa, sa)
	local t = 0
	local csa = sec:alpha()
	local cpa = prim:alpha()
	while t < 0.5 do
		t = t + coroutine.yield()
		local n = math.sin( t * 200 ) 
		sec:set_alpha(math.lerp(csa, sa, n))
		prim:set_alpha(math.lerp(cpa, pa, n))
	end
	sec:set_alpha(sa)
	prim:set_alpha(pa)
end
function HUDTeammate:set_ammo_amount_by_type(type, max_clip, current_clip, current_left, max)
	if LDDG:GetSetting("FixedAmmoTotal") and ((type == "primary" and managers.blackmarket:equipped_primary().weapon_id ~= "saw") or (type == "secondary" and managers.blackmarket:equipped_secondary().weapon_id ~= "saw_secondary") ) then
		current_left = current_left - current_clip
	end	
	local weapon_panel = self._player_panel:child(type .. "_panel")
	local low_ammo = current_left <= math.round(max_clip / 2)
	local low_ammo_clip = current_clip <= math.round(max_clip / 4)
	local out_of_ammo_clip = current_clip <= 0
	local out_of_ammo = current_left <= 0
	local color_total = out_of_ammo and Color(1, 0.9, 0.3, 0.3)
	color_total = color_total or low_ammo and Color(1, 0.9, 0.9, 0.3)
	color_total = color_total or LDDG:GetColor("TeammatesColor")
	local color_clip = out_of_ammo_clip and Color(1, 0.9, 0.3, 0.3)
	color_clip = color_clip or low_ammo_clip and Color(1, 0.9, 0.9, 0.3)
	color_clip = color_clip or LDDG:GetColor("TeammatesColor")
	local ammo_clip = weapon_panel:child("current_clip")
	ammo_clip:set_text(tostring(current_clip))
	ammo_clip:animate(callback(nil, _G, "set_color"), color_clip)
	local ammo_total = weapon_panel:child("total_ammo")
	ammo_total:set_text(tostring(current_left))
	ammo_total:animate(callback(nil, _G, "set_color"), color_total)
end
function HUDTeammate:add_special_equipment(data)
	local scale = LDDG:GetSetting("HudScale")	
	local color = LDDG:GetColor("TeammatesColor")
	local teammate_panel = self._panel
	local special_equipment = self._special_equipment
	local id = data.id
	local equipment_panel = teammate_panel:panel({
		name = id,
		layer = 0,
		y = 0
	})
	local icon, texture_rect = tweak_data.hud_icons:get_icon_data(data.icon)
	equipment_panel:set_size(24 * scale, 24 * scale)
	local bitmap = equipment_panel:bitmap({
		name = "bitmap",
		texture = icon,
		color = color,
		layer = 1,
		texture_rect = texture_rect,
		w = equipment_panel:w(),
		h = equipment_panel:w()
	})
	local amount, amount_bg
	if data.amount then
		amount = equipment_panel:child("amount") or equipment_panel:text({
			name = "amount",
			text = tostring(data.amount) .. "0",
			font = "fonts/font_large_mf",
			font_size = 16 * scale,
			color = color == Color.white and Color.black or Color.white,
			align = "center",
			vertical = "center",
			layer = 4,
			w = 16 * scale,
			h = 16 * scale,
		})
		amount:set_visible(1 < data.amount)
		amount_bg = equipment_panel:child("amount_bg") or equipment_panel:bitmap({
			name = "amount_bg",
			color = color,
			w = 16 * scale,
			h = 16 * scale,
			layer = 3
		})
		amount_bg:set_visible(1 < data.amount)
	end
	table.insert(special_equipment, equipment_panel)
	local w = teammate_panel:w()
	equipment_panel:set_x(w - (equipment_panel:w() + 0) * #special_equipment)
	if amount then
		amount_bg:set_center(bitmap:center())
		amount_bg:move(7, 7)
		amount:set_center(amount_bg:center())
		amount:move(-1)
	end
	local hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2)
	self:layout_special_equipments()
end
function HUDTeammate:layout_special_equipments()
	local scale = LDDG:GetSetting("HudScale")
	local color = LDDG:GetColor("TeammatesColor")	
	for i, panel in ipairs(self._special_equipment) do
		local bitmap = panel:child("bitmap")
		local amount = panel:child("amount")
		local amount_bg = panel:child("amount_bg")
		panel:set_size(24 * scale, 24 * scale)
		bitmap:set_size(panel:w() - 4, panel:w() - 4)
		bitmap:set_color(color)
		if amount then		
			amount:set_font_size(16 * scale)
			amount:set_color(color == Color.white and Color.black or Color.white)
			amount:set_size(16 * scale, 16 * scale)
			amount_bg:set_color(color)
			amount_bg:set_size(amount:size())
			amount_bg:set_center(bitmap:center())
			amount_bg:move(7, 7)
			amount:set_center(amount_bg:center())
			amount:move(-1)
		end
		if self._main_player then
			panel:set_x(self._panel:w() - (panel:w() + 0) * i)
		else
			panel:set_x(panel:w() * (i - 1))
		end			
		panel:set_bottom(self._player_panel:child("deployable_equipment_panel"):top() - 2)
	end
end
function HUDTeammate:teammate_progress(enabled, tweak_data_id, timer, success)
	self._player_panel:child("interact_panel"):hide()
end
function HUDTeammate:start_timer(time)
	self._timer_paused = 0
	self._timer = time
	self._panel:child("condition_timer"):set_color(Color.black)
	self._panel:child("condition_timer"):stop()
	self._panel:child("condition_timer"):show()
	self._panel:child("condition_timer"):animate(callback(self, self, "_animate_timer"))
end
function HUDTeammate:set_stored_health_max(stored_health_ratio)
	local bar = self._player_panel:child("bar1_bg")
	if alive(bar) then
		local red = math.min(stored_health_ratio, 1)
		bar:set_visible(red > 0)
		bar:set_w(self._panel:child("portrait"):w() * red)
	end
end
function HUDTeammate:set_stored_health(stored_health_ratio)
	local scale = LDDG:GetSetting("HudScale")
	local bar = self._player_panel:child("bar1")
	if alive(bar) then
		local red = math.min(stored_health_ratio, 1)
		bar:set_visible(red > 0)
		bar:set_w(self._panel:child("portrait"):w() * red)
	end
end
function HUDTeammate:_animate_update_absorb(o, radial_absorb_shield_name, radial_absorb_health_name, var_name, blink)
	repeat
		coroutine.yield()
	until alive(self._panel) and self[var_name] and self._armor_data and self._health_data

	local radial_health_panel = self._player_panel:child("radial_health_panel")
	local radial_shield = radial_health_panel:child("radial_shield")
	local radial_health = radial_health_panel:child("radial_health")
	local absorb_shield = self._player_panel:child("bar2")
	local absorb_health = self._player_panel:child("bar1")
	local radial_shield_rot = radial_shield:color().r
	local radial_health_rot = radial_health:color().r
	local current_absorb = 0
	local current_shield, current_health
	local step_speed = 1
	local lerp_speed = 1
	local dt, update_absorb
	local t = 0
	log("hey")
	while alive(self._player_panel) do
		dt = coroutine.yield()
		if self[var_name] and self._armor_data and self._health_data then
			update_absorb = false
			current_shield = self._armor_data.current
			current_health = self._health_data.current
			if current_absorb ~= self[var_name] then
				current_absorb = math.lerp(current_absorb, self[var_name], lerp_speed * dt)
				current_absorb = math.step(current_absorb, self[var_name], step_speed * dt)
				update_absorb = true
			end
			if update_absorb and current_absorb > 0 then
				local shield_ratio = current_shield == 0 and 0 or math.min(current_absorb / current_shield, 1)
				local health_ratio = current_health == 0 and 0 or math.min((current_absorb - shield_ratio * current_shield) / current_health, 1)
				local shield = math.clamp(shield_ratio * radial_shield_rot, 0, 1)
				local health = math.clamp(health_ratio * radial_health_rot, 0, 1)
				absorb_shield:set_w(self._panel:child("portrait"):w() * shield)
				absorb_health:set_w(self._panel:child("portrait"):w() * health)
				absorb_shield:set_visible(shield > 0)
				absorb_health:set_visible(health > 0)
			end
		end
	end
end