Hooks:PostHook(HUDPlayerDowned, "init", "hudplayerdowned_lddg", function(self, hud, ...)	
	self:UpdateLDDG()
end)
function HUDPlayerDowned:UpdateLDDG(hud)
	local scale = LDDG:GetSetting("HudScale")
	local downed_panel = self._hud_panel:child("downed_panel")
	local timer_msg = downed_panel:child("timer_msg")

	timer_msg:configure({
		w = 400 * scale,
		font_size = 24 * scale,
	})	
	local _, _, w, h = timer_msg:text_rect()
	timer_msg:set_h(h)
	timer_msg:set_x(math.round(self._hud_panel:center_x() - timer_msg:w() / 2))
	timer_msg:set_y(24 * scale)

	self._hud.arrest_finished_text:set_font_size(24 * scale)
	local _, _, w, h = self._hud.arrest_finished_text:text_rect()
	self._hud.arrest_finished_text:set_h(h)
	self._hud.arrest_finished_text:set_y(24 * scale)
	self._hud.arrest_finished_text:set_center_x(self._hud_panel:center_x())	

	self._hud.timer:set_font_size(24 * scale)
	local _, _, w, h = self._hud.timer:text_rect()		
	self._hud.timer:set_h(h)
	self._hud.timer:set_top(self._hud.arrest_finished_text:bottom())
	self._hud.timer:set_center_x(self._hud_panel:center_x())
end
function HUDPlayerDowned:show_timer()
	local downed_panel = self._hud_panel:child("downed_panel")
	local timer_msg = downed_panel:child("timer_msg")
	timer_msg:set_visible(true)
	self._hud.timer:set_visible(true)

	timer_msg:animate(callback(nil, _G, "set_alpha"), 1)
	self._hud.timer:animate(callback(nil, _G, "set_alpha"), 1)
end
function HUDPlayerDowned:hide_timer()
	local downed_panel = self._hud_panel:child("downed_panel")
	local timer_msg = downed_panel:child("timer_msg")
	timer_msg:animate(callback(nil, _G, "set_alpha"), 0.65)
	self._hud.timer:animate(callback(nil, _G, "set_alpha"), 0.65)
end
